// Attract-Mode layout theme SDAMax III
// Inspired by and hacked from the SDcaptain theme originally ported to Attract Mode by jedione and modified for the ARpiCADE by Dee2er
// Visit my blog at www.idahogaragecade.com

// Layout options

local col = "white,grey 50%,grey 75%,blue, light blue,green,red,ruby,orange,violet,yellow,yellow orange,"; //Added List of Colors to be used for any text - 01/22/2019
local o=0;
local header = "● "
local subheader = "  ○ "
local headerend = "                                                                                                   "

class UserConfig
{ 
	</ label=header + "Background/Preview Options" + headerend, help="Select background options", options=" ", order=o++ /> divider1="";
	
	</ label=subheader + "Preview scroll speed" + headerend, help="Adjust game preview scroll speed.", options="Fast,Normal,Slow", order=o++ /> preview_speed="Normal";
	</ label=subheader + "Preview scroll direction" + headerend, help="Adjust game preview scroll direction.", options="Left-Right,Up-Down", order=o++ /> preview_direction="Left-Right";
	
	</ label=header + "Header/Logo Options" + headerend, help="Select background options", options=" ", order=o++ /> divider2="";	
	
	</ label=subheader + "Header type" + headerend, help="adjust logo animation type", options="Wheel,Marquee", order=o++ /> header_type="Wheel";
	</ label=subheader + "Header location" + headerend, help="adjust logo location", options="Left,Right,Center", order=o++ /> header_location="Right";
	</ label=subheader + "Header animation" + headerend, help="adjust logo animation type", options="zoom,single bounce,bounce two,zoom out,slide,shadow,shadow 2,shadow 3,shadow 4", order=o++ /> animation_type="shadow";
	</ label=subheader + "Force header aspect-ratio" + headerend, help="Force image header aspect-ratio (recommended ON for horizontally oriented systems)", options="on,off", order=o++ /> header_aspect="on";

	</ label=header + "Features Options" + headerend, help="Select background options", options=" ", order=o++ /> divider3="";	
	
	</ label=subheader + "Display Progress Bar" + headerend, help="Display progress bar.", options="vertical,horizontal,none", order=o++ /> progress="horizontal";
	</ label=subheader + "Include players/genre info?" + headerend, help="Toggle on/off number of players & genre category", options="on,off", order=o++ /> playersgenre_info="on";
	</ label=subheader + "Include favorites?" + headerend, help="Toggle on/off favorites", options="on,off", order=o++ /> favorites="on";
	</ label=subheader + "Favorites star location" + headerend, help="Favorites star location", options="bottom,top", order=o++ /> favorites_loc="top";
	</ label=subheader + "Game Text info" + headerend, help="Toggle No Title / Title / Title + Extras.", options="title,extra,false", order=o++ /> title="extra";
	</ label=subheader + "Include Times played info?" + headerend, help="Toggle On/Off Times Played Info", options="true,false", order=o++ /> label_play="true";
	</ label=subheader + "Game#/Times Played Location" + headerend, help="Game # & Times Played Info Location", options="top,bottom", order=o++ /> label_position="bottom";
	</ label=subheader + "Monitor rotation" + headerend, help="Monitor rotation.",options="horizontal,vertical", order=o++ /> rotation="vertical";
	
	</ label=header + "Color Options" + headerend, help="Select background options", options=" ", order=o++ /> divider4="";		
	
	</ label=subheader + "Title Text Color" + headerend, help="Color of game title text", options=col, order=o++ /> title_color="yellow";
	</ label=subheader + "Message Text Color" + headerend, help="Color of pulsing message text", options=col, order=o++ /> pulse_color="yellow";
	</ label=subheader + "Manufacturer Text Color" + headerend, help="Color of game manufacturer text color", options=col, order=o++ /> man_color="white";
	</ label=subheader + "Times Played Color" + headerend, help="Color of times played text", options=col, order=o++ /> play_color="white";
	</ label=subheader + "Game X of X Color" + headerend, help="Color of games x of x text", options=col, order=o++ /> gamenumber_color="white";
	</ label=subheader + "Progress Bar Letter Color" + headerend, help="Color of progress bar letter color", options=col, order=o++ /> slider_color="white";
	
	</ label=header + "Message Options" + headerend, help="Select background options", options=" ", order=o++ /> divider5="";		
	
	</ label=subheader + "Alt MSG#1" + headerend, help="Alternate message to display under preview image.", order=o++ /> msg1="Wait For Game to Coin Up"
	</ label=subheader + "Message #2" + headerend, help="Message to display flashing at bottom of screen.", order=o++ /> msg2="Select Game With Joystick";
}
local my_config = fe.get_config();

// General setup

fe.layout.width=640;
fe.layout.height=480;
local flx = fe.layout.width;
local fly = fe.layout.height;
local flw = fe.layout.width;
local flh = fe.layout.height;

// Set vertical orientation

if (my_config["rotation"] == "vertical" )
{
fe.layout.orient=RotateScreen.Right;
}

// Load modules

fe.load_module("animate");
fe.do_nut ( "scripts/carrier.nut" );
fe.do_nut ( "scripts/colors.nut" ); // Color.nut by Giacomo Bianchi 10/30/2018

// Snap carrier setup

if (my_config["preview_direction"] == "Left-Right" )
{
	if (my_config["preview_speed"] == "Fast" )
	{
		local carrier = Carrier( 0, 0, flw*1.00, flh*1.00, 1, 1, 0, 0, 0 )
		carrier.surfacePosSmoothing = 0.78
	}
	if (my_config["preview_speed"] == "Normal" )
	{
		local carrier = Carrier( 0, 0, flw*1.00, flh*1.00, 1, 1, 0, 0, 0 )
		carrier.surfacePosSmoothing = 0.90
	}
	if (my_config["preview_speed"] == "Slow" )
	{
		local carrier = Carrier( 0, 0, flw*1.00, flh*1.00, 1, 1, 0, 0, 0 )
		carrier.surfacePosSmoothing = 0.93
	}
}

if (my_config["preview_direction"] == "Up-Down" )
{
	if (my_config["preview_speed"] == "Fast" )
	{
		local carrier = Carrier( 0, 0, flw*1.00, flh*1.34, 1.34, 1, 0, 0, 0 )
		carrier.surfacePosSmoothing = 0.78
	}
	if (my_config["preview_speed"] == "Normal" )
	{
		local carrier = Carrier( 0, 0, flw*1.00, flh*1.34, 1.34, 1, 0, 0, 0 )
		carrier.surfacePosSmoothing = 0.90
	}
	if (my_config["preview_speed"] == "Slow" )
	{
		local carrier = Carrier( 0, 0, flw*1.00, flh*1.34, 1.34, 1, 0, 0, 0 )
		carrier.surfacePosSmoothing = 0.93
	}
}
	
// Videotheme timer Code by qqplayer

::OBJECTS1 <- {
artwork_videotheme = fe.add_artwork("snap", flx*0.00, fly*0.00, flw*1.00, flh*1.00),
}

OBJECTS1.artwork_videotheme.visible=false;

::videoSound <- Vid.NoAudio;
OBJECTS1.artwork_videotheme.video_flags = videoSound;

local settings = {
   delay_timer = 0,
   play_delay = 2000,
   stop_play = 235000,
}

function on_transition_videotheme( ttype, var, ttime ) {
 switch ( ttype ) {
  case Transition.StartLayout:
  case Transition.ToNewSelection:
  case Transition.ToNewList:
  case Transition.EndNavigation:
        OBJECTS1.artwork_videotheme.video_flags = Vid.NoAutoStart;
        settings.delay_timer = fe.layout.time;
        OBJECTS1.artwork_videotheme.visible=false;
       break;
  }
 return false;
}

fe.add_transition_callback( "on_transition_videotheme" );

function on_tick_videotheme(tick_time) {
   if ( !OBJECTS1.artwork_videotheme.video_playing && tick_time - settings.delay_timer >= settings.play_delay ) {
   
        OBJECTS1.artwork_videotheme.video_playing = true;
        
        ::videoSound <- Vid.Default;
        OBJECTS1.artwork_videotheme.video_flags = videoSound;        
        
        OBJECTS1.artwork_videotheme.visible=true;
        
        OBJECTS1.artwork_videotheme.alpha = 0
        local alpha_artwork_videotheme_0 = {
        property = "alpha", start = 0 end = 255, time = 500 easing = Easing.Out,
        }
 
        animation.add( PropertyAnimation( OBJECTS1.artwork_videotheme, alpha_artwork_videotheme_0 ) );       
    }
    
    else if ( tick_time - settings.delay_timer >= settings.stop_play ) {
        
        OBJECTS1.artwork_videotheme.visible=false;      
    }
}

fe.add_ticks_callback(this, "on_tick_videotheme");

// Wheel or marquee

	if (my_config["header_location"] == "Right" )
	{
	local artx = flx*0.570;
	local arty = fly*0.090;
	local artz = fly*0.125;
	
	if (my_config["animation_type"] == "shadow 4" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.040,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.040,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}		
	
	if (my_config["animation_type"] == "shadow 3" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.9,
			end = 1.0,
			time = 0350,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.9,
			end = 1.0,
			time = 0350,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
if (my_config["animation_type"] == "shadow 2" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.560 fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 255;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
	if (my_config["animation_type"] == "shadow" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.560, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
	if (my_config["animation_type"] == "zoom" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0700,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0700,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
	
if (my_config["animation_type"] == "bounce two" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1500,
			tween = Tween.Bounce,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
		
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1500,
			tween = Tween.Bounce,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
}

if (my_config["animation_type"] == "single bounce" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
	
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
}

if (my_config["animation_type"] == "slide" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.2,
			end = arty,
			time = 350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
		}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.2,
			end = arty,
			time = 700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}

if (my_config["animation_type"] == "zoom out" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.5,
			end = 1.0,
			time = 1000,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 350 ,
		}	
	animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}

	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.4,
			end = 1.0,
			time = 1000,
			tween = Tween.Bounce,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 350 ,
		}	
	animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
}

if (my_config["header_location"] == "Left" )
	{
	local artx = flx*0.067;
	local arty = fly*0.090;
	local artz = fly*0.145;
	
		if (my_config["animation_type"] == "shadow 4" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{
				marquee.preserve_aspect_ratio = true;
			}
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.040,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.040,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
	
	if (my_config["animation_type"] == "shadow 3" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.9,
			end = 1.0,
			time = 0350,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.9,
			end = 1.0,
			time = 0350,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
	
	
	if (my_config["animation_type"] == "shadow 2" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 255;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
	if (my_config["animation_type"] == "shadow" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.060, fly*0.078, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
if (my_config["animation_type"] == "zoom" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0700,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0700,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
	
if (my_config["animation_type"] == "bounce two" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1500,
			tween = Tween.Bounce,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
		
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1500,
			tween = Tween.Bounce,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
}

if (my_config["animation_type"] == "single bounce" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
	
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
}

if (my_config["animation_type"] == "slide" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.2,
			end = arty,
			time = 350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
		}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.2,
			end = arty,
			time = 700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}

if (my_config["animation_type"] == "zoom out" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.5,
			end = 1.0,
			time = 1000,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 350 ,
		}	
	animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}

	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.4,
			end = 1.0,
			time = 1000,
			tween = Tween.Bounce,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 350 ,
		}	
	animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
}

if (my_config["header_location"] == "Center" )
	{
	local artx = flx*0.30;
	local arty = fly*0.030;
	local artz = fly*0.145;

		if (my_config["animation_type"] == "shadow 4" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{
				marquee.preserve_aspect_ratio = true;
			}
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.060,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.060,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}

	if (my_config["animation_type"] == "shadow 3" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{
				marquee.preserve_aspect_ratio = true;
			}
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.9,
			end = 1.0,
			time = 0350,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.9,
			end = 1.0,
			time = 0350,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
	
if (my_config["animation_type"] == "shadow 2" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 255;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}		
	
if (my_config["animation_type"] == "shadow" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", flx*0.293, fly*0.018, flw*0.415, flh*0.210 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		marquee.set_rgb (0,0,0);
		marquee.alpha = 150;
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0300,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0300 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}	
	
if (my_config["animation_type"] == "zoom" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0700,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.0,
			end = 1.0,
			time = 0700,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 0700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
	
if (my_config["animation_type"] == "bounce two" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1500,
			tween = Tween.Bounce,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
		
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1500,
			tween = Tween.Bounce,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
}

if (my_config["animation_type"] == "single bounce" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
	
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 0.1,
			end = 1.0,
			time = 1000,
			tween = Tween.Back,
		}
		animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	}
}

if (my_config["animation_type"] == "slide" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.2,
			end = arty,
			time = 350 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
		}
	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = fly*-0.2,
			end = arty,
			time = 700 ,
		}	
		animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}

if (my_config["animation_type"] == "zoom out" )
{
	if (my_config["header_type"] == "Wheel" )
	{
		local marquee = fe.add_artwork( "wheel", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.5,
			end = 1.0,
			time = 1000,
			tween = Tween.Linear,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 350 ,
		}	
	animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}

	if (my_config["header_type"] == "Marquee" )
	{
		local marquee = fe.add_artwork( "marquee", artx, arty, flw*0.400, flh*0.185 );
		if (my_config["header_aspect"] == "on" )
			{ marquee.preserve_aspect_ratio = true; }
		local marquee_scale_cfg = {
			when =Transition.ToNewSelection,
			property = "scale",
			start = 1.4,
			end = 1.0,
			time = 1000,
			tween = Tween.Bounce,
		}
		local marquee_move_cfg = {
			when =Transition.ToNewSelection,
			property = "y",
			start = artz,
			end = arty,
			time = 350 ,
		}	
	animation.add( PropertyAnimation( marquee, marquee_scale_cfg ) );
	animation.add( PropertyAnimation( marquee, marquee_move_cfg ) );
	}
}
}

// Text bits

if (my_config["label_play"] == "true" )
{
	if (my_config["label_position"] == "top" )
	{
	local label_play = fe.add_text(" PLAYED [PlayedCount] TIMES ", flx*0.004, fly*0.014, flw*1.000, flh*0.050 );
		label_play.align = Align.Right;
		label_play.font = "captain";
		label_play.charsize = 17.5;
		label_play.alpha = 255;
		label_play.set_rgb ( 0, 0, 0 );
	local label_play = fe.add_text(" PLAYED [PlayedCount] TIMES ", flx*0.000, fly*0.010, flw*1.000, flh*0.050 );
		label_play.align = Align.Right;
		label_play.font = "captain";
		label_play.charsize = 17.5;
		colors( label_play, my_config["play_color"], 0 );	
	}
	if (my_config["label_position"] == "bottom" )
	{
	local label_play = fe.add_text(" PLAYED [PlayedCount] TIMES ", flx*0.004, fly*0.943, flw*1.000, flh*0.050 );
		label_play.align = Align.Right;
		label_play.font = "captain";
		label_play.charsize = 17.5;
		label_play.alpha = 255;
		label_play.set_rgb ( 0, 0, 0 );
	local label_play = fe.add_text(" PLAYED [PlayedCount] TIMES ", flx*0.000, fly*0.939, flw*1.000, flh*0.050 );
		label_play.align = Align.Right;
		label_play.font = "captain";
		label_play.charsize = 17.5;
		colors( label_play, my_config["play_color"], 0 );	
	}
}

local pulse = fe.add_text( my_config["msg2"], flx*0.004, fly*0.884, flw*1.000, flh*0.050 );
local pulse_text_cfg = {
	when =Transition.ToNewList,
	property = "alpha",
	start = 0, 
	end = 150,
	time = 1000,
	tween = Tween.Quad,
	pulse = true,
	font = "captain",
}
animation.add( PropertyAnimation( pulse, pulse_text_cfg ) );
pulse.font = "captain";
pulse.charsize = 20;
pulse.alpha= 255;
pulse.set_rgb ( 0 , 0 , 0 );
	
local pulse = fe.add_text( my_config["msg2"], flx*0.000, fly*0.880, flw*1.000, flh*0.050 );
	local pulse_text_cfg = {
		when =Transition.ToNewList,
		property = "alpha",
		start = 50, 
		end = 255,
		time = 1000,
		tween = Tween.Quad,
		pulse = true,
		font = "captain",
}
	
	animation.add( PropertyAnimation( pulse, pulse_text_cfg ) );
	pulse.font = "captain";
	pulse.charsize = 20;
	pulse.alpha= 255;
	colors( pulse, my_config["pulse_color"], 0 );	
	
if (my_config["title"] == "extra" )
{
	local text = fe.add_text("[Title]", flx*0.164, fly*0.768, flw*0.680, flh*0.050 );
	text.font="captain";
	text.charsize = 35;
	text.set_rgb ( 0 , 0 , 0 );
	
	local text = fe.add_text("[Title]", flx*0.160, fly*0.764, flw*0.680, flh*0.050 );
	text.font="captain";
	text.charsize = 35;
	colors( text, my_config["title_color"], 0 );
	text.alpha = 255;

	local text = fe.add_text("[Year] - [Manufacturer]", flx*0.164, fly*0.834, flw*0.680, flh*0.050 );
	text.font="captain";
	text.charsize = 23;
	text.set_rgb ( 0 , 0 , 0 );
	
	local text = fe.add_text("[Year] - [Manufacturer]", flx*0.160, fly*0.830, flw*0.680, flh*0.050 );
	text.font="captain";
	text.charsize = 23;
	colors( text, my_config["man_color"], 0 );
	text.alpha = 255;
	
if (my_config["label_play"] == "true" )
	{
		if (my_config["label_position"] == "top" )
		{
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.004, fly*0.010, flw*1.000, flh*0.050 );
		text.align = Align.Left;
		text.font="captain";
		text.charsize = 17.5;
		text.alpha = 255;
		text.set_rgb ( 0, 0, 0);
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.000, fly*0.006, flw*1.000, flh*0.050 );
		text.align = Align.Left;
		text.font="captain";
		text.charsize = 17.5;
		colors( text, my_config["gamenumber_color"], 0 );	
		}
		if (my_config["label_position"] == "bottom" )
		{
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.004, fly*0.943, flw*1.000, flh*0.050 );
		text.align = Align.Left;
		text.font="captain";
		text.charsize = 17.5;
		text.alpha = 255;
		text.set_rgb ( 0, 0, 0 );
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.000, fly*0.939, flw*1.000, flh*0.050 );
		text.align = Align.Left;
		text.font="captain";
		text.charsize = 17.5;
		colors( text, my_config["gamenumber_color"], 0 );
		}
	}
if (my_config["label_play"] == "false" )
	{
		if (my_config["label_position"] == "top" )
		{
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.004, fly*0.010, flw*1.000, flh*0.050 );
		text.align = Align.Left;
		text.font="captain";
		text.charsize = 17.5;
		text.set_rgb ( 0, 0, 0 );	
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.000, fly*0.006, flw*1.000, flh*0.050 );
		text.align = Align.Left;
		text.font="captain";
		text.charsize = 17.5;
		colors( text, my_config["gamenumber_color"], 0 );
		}
		if (my_config["label_position"] == "bottom" )
		{
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.004, fly*0.943, flw*1.000, flh*0.050 );
		text.font="captain";
		text.charsize = 17.5;
		text.alpha = 255;
		text.set_rgb ( 0, 0, 0 );
		local text = fe.add_text(" [ListEntry] OF [ListSize] ", flx*0.000, fly*0.939, flw*1.000, flh*0.050 );
		text.font="captain";
		text.charsize = 18;
		colors( text, my_config["gamenumber_color"], 0 );
		}
	}	
}

if (my_config["title"] == "title" )
{
	local text = fe.add_text("[Title]", flx*0.164, fly*0.824, flw*0.680, flh*0.050 );
	text.font="captain";
	text.charsize = 35;
	text.set_rgb ( 0 , 0 , 0 );
		
	local text = fe.add_text("[Title]", flx*0.160, fly*0.820, flw*0.680, flh*0.050 );
	text.font="captain";
	text.charsize = 35;
	colors( text, my_config["title_color"], 0 );
}

if (my_config["title"] == "false" )
{	
	local text = fe.add_text( my_config["msg1"], flx*0.000, fly*0.815, flw*1.000, flh*0.050 );
	text.font="captain";
	text.charsize = 32;
	text.alpha = 255;
}

// Favorites

if (my_config["favorites"] == "on" )
{
	if (my_config["rotation"] == "horizontal" )
	{
		if (my_config["favorites_loc"] == "top" )
		{
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.000, fly*0.050, flw*0.062, flh*0.089);
			Fav.set_rgb (0,0,0);
			Fav.alpha = 150;
			local Fav_scale_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 0.0,
				end = 1.0,
				time = 1500,
				tween = Tween.Linear,
			}
			
			local Fav = fe.add_image("[!FavStar]", flx*0.006, fly*0.062, flw*0.052, flh*0.070);
			local Fav_move_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 3.5,
				end = 1.0,
				time = 1500,
				tween = Tween.Bounce,
			}	
			animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
		}
		
		if (my_config["favorites_loc"] == "bottom" )
		{
			if (my_config["playersgenre_info"] =="on")
			{
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.080, fly*0.603, flw*0.080, flh*0.120);
			Fav.set_rgb (0,0,0);
			Fav.alpha = 150;
			local Fav_scale_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 0.0,
				end = 1.0,
				time = 1500,
				tween = Tween.Linear,
			}
			
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.088, fly*0.615, flw*0.065, flh*0.098);
			local Fav_move_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 3.5,
				end = 1.0,
				time = 1500,
				tween = Tween.Bounce,
			}	
			animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
			}
			if (my_config["playersgenre_info"] =="off")
			{
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.008, fly*0.828, flw*0.095, flh*0.132);
			Fav.set_rgb (0,0,0);
			Fav.alpha = 150;
			local Fav_scale_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 0.0,
				end = 1.0,
				time = 1500,
				tween = Tween.Linear,
			}
			
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.015, fly*0.840, flw*0.080, flh*0.110);
			local Fav_move_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 3.5,
				end = 1.0,
				time = 1500,
				tween = Tween.Bounce,
			}	
			animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
			}
		}
	}
	if (my_config["rotation"] == "vertical" )
	{
		if (my_config["favorites_loc"] == "top" )
		{
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.015, fly*0.075, flw*0.050, flh*0.038);
			local Fav_move_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 3.5,
				end = 1.0,
				time = 1500,
				tween = Tween.Bounce,
			}	
			animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
		}

	if (my_config["favorites_loc"] == "bottom" )
		{
			if (my_config["playersgenre_info"] =="on")
			{
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.070, fly*0.660, flw*0.075, flh*0.057);
			local Fav_move_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 3.5,
				end = 1.0,
				time = 1500,
				tween = Tween.Bounce,
			}	
			animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
			}
			if (my_config["playersgenre_info"] =="off")
			{
			function FavStar() {
			if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
			}
			local Fav = fe.add_image("[!FavStar]", flx*0.015, fly*0.870, flw*0.100, flh*0.076);
			local Fav_move_cfg = {
				when =Transition.ToNewSelection,
				property = "scale",
				start = 3.5,
				end = 1.0,
				time = 1500,
				tween = Tween.Bounce,
			}	
			animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
			}
		}
	}
}

if (my_config["playersgenre_info"] =="on")
	{
	if (my_config["label_position"] =="bottom")
	{
	// Add Number of Players 
	local pb_x = flx*0.830;
	local pb_y = fly*0.720;
	local pb_w = flw*0.157;
	local pb_h = flh*0.112;
	local pb_text_x = pb_x-(flx*0.006);
	local pb_text_y = pb_y+(fly*0.018);
	local pb_text_w = pb_w;
	local pb_text_h = pb_h-(flh*0.045);
	//New function
	function PlayerIcon() {
	if (fe.game_info( Info.Players ) >= "1") return "images/players.png";
	else if (fe.game_info( Info.Players ) <= "" || " ") return "images/unknownp.png";
	}
	//end of new function
	local PlayerIcon= fe.add_image("[!PlayerIcon]", pb_x, pb_y, pb_w, pb_h);
	local p = fe.add_text( "[Players]", pb_text_x, pb_text_y, pb_text_w, pb_text_h);
	p.charsize = 42;
	p.set_rgb( 0, 0, 0 );
	p.font="Roboto";
	p.align = Align.Centre;
	p.style = Style.Bold;
	
	// Add Genre images
	local genre_image = fe.add_image("images/unknown.png", flx*0.830, fly* 0.835, flw*0.157, flh*0.112);
	genre_image.trigger = Transition.EndNavigation;	

	class GenreImage
   {
    mode = 1;       //0 = first match, 1 = last match, 2 = random
    supported = {
        //filename : [ match1, match2 ]
        "act": [ "action","platformer", "platform" ],
		"plt": [ "platformer", "platform" ],
        "avg": [ "adventure" ],
        "ftg": [ "fighting", "fighter", "beat'em up" ],
        "pzg": [ "puzzle" ],
		"mze": [ "maze" ],
		"rhy": [ "rhythm" ],
		"pbl": [ "pinball" ],
        "rcg": [ "racing", "driving" ],
        "rpg": [ "rpg", "role playing", "role-playing", "role playing game" ],
        "stg": [ "shooter", "shmup" ],
        "fly": [ "fly", "flying" ],
        "spt": [ "sports", "boxing", "golf", "baseball", "football", "soccer" "Sports" ],
        "bxg": [ "boxing" ],
        "slg": [ "strategy"]
    }
    ref = null;
    constructor( image )
    {
        ref = image;
        fe.add_transition_callback( this, "transition" );
    }
    
    function transition( ttype, var, ttime )
    {
        if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
        {
            local cat = " " + fe.game_info(Info.Category, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
	}
GenreImage(genre_image);
}
if (my_config["label_position"] =="top")
	{
	// Add Number of Players 
	local pb_x = flx*0.830;
	local pb_y = fly*0.720;
	local pb_w = flw*0.157;
	local pb_h = flh*0.112;
	local pb_text_x = pb_x-(flx*0.006);
	local pb_text_y = pb_y+(fly*0.018);
	local pb_text_w = pb_w;
	local pb_text_h = pb_h-(flh*0.045);
	//New function
	function PlayerIcon() {
	if (fe.game_info( Info.Players ) >= "1") return "images/players.png";
	else if (fe.game_info( Info.Players ) <= "" || " ") return "images/unknownp.png";
	}
	//end of new function
	local PlayerIcon= fe.add_image("[!PlayerIcon]", pb_x, pb_y, pb_w, pb_h);
	local p = fe.add_text( "[Players]", pb_text_x, pb_text_y, pb_text_w, pb_text_h);
	p.charsize = 42;
	p.set_rgb( 0, 0, 0 );
	p.font="Roboto";
	p.align = Align.Centre;
	p.style = Style.Bold;
	
	// Add Genre images
	local genre_image = fe.add_image("images/unknown.png", flx*0.830, fly* 0.835, flw*0.157, flh*0.112);
	genre_image.trigger = Transition.EndNavigation;	

	class GenreImage
   {
    mode = 1;       //0 = first match, 1 = last match, 2 = random
    supported = {
        //filename : [ match1, match2 ]
        "act": [ "action","platformer", "platform" ],
		"plt": [ "platformer", "platform" ],
        "avg": [ "adventure" ],
        "ftg": [ "fighting", "fighter", "beat'em up" ],
        "pzg": [ "puzzle" ],
		"mze": [ "maze" ],
		"rhy": [ "rhythm" ],
		"pbl": [ "pinball" ],
        "rcg": [ "racing", "driving" ],
        "rpg": [ "rpg", "role playing", "role-playing", "role playing game" ],
        "stg": [ "shooter", "shmup" ],
        "fly": [ "fly", "flying" ],
        "spt": [ "sports", "boxing", "golf", "baseball", "football", "soccer" "Sports" ],
        "bxg": [ "boxing" ],
        "slg": [ "strategy"]
    }
    ref = null;
    constructor( image )
    {
        ref = image;
        fe.add_transition_callback( this, "transition" );
    }
    
    function transition( ttype, var, ttime )
    {
        if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
        {
            local cat = " " + fe.game_info(Info.Category, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
	}
GenreImage(genre_image);
}
}


	// Add Control images
	local control_image = fe.add_image("images/unknown.png", flx*0.015, fly* 0.720, flw*0.157, flh*0.112);
	control_image.trigger = Transition.EndNavigation;	

	class ControlImage
   {
    mode = 1;       //0 = first match, 1 = last match, 2 = random
    supported = {
        //filename : [ match1, match2 ]
        "8way": [ "joystick (8-way)" ],
		"4way": [ "joystick (4-way)" ],
		"2way": [ "joystick (2-way)" ],
        "analog": [ "analog", "positional" ],
        "spin": [ "dial", "paddle" ],
        "track": [ "trackball" ],
		"gun": [ "lightgun" ],
		"2sticks": [ "double joystick (8-way)", "double joystick (4-way)", "double joystick (2-way)", "vertical double joystick (8-way)", "vertical double joystick (4-way)", "vertical double joystick (2-way)"  ],
		"butonly": [ "only_buttons" ]
    }
    ref = null;
    constructor( image )
    {
        ref = image;
        fe.add_transition_callback( this, "transition" );
    }
    
    function transition( ttype, var, ttime )
    {
        if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
        {
            local cat = " " + fe.game_info(Info.Control, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
	}
ControlImage(control_image);

	// Add Buttons images
	local buttons_image = fe.add_image("images/unknown.png", flx*0.015, fly* 0.835, flw*0.157, flh*0.112);
	buttons_image.trigger = Transition.EndNavigation;	

	class ButtonsImage
   {
    mode = 1;       //0 = first match, 1 = last match, 2 = random
    supported = {
        //filename : [ match1, match2 ]
        "0buttons": [ "0" ],
		"1button": [ "1" ],
		"2buttons": [ "2" ],
        "3buttons": [ "3" ],
        "4buttons": [ "4" ],
        "5buttons": [ "5" ],
		"6buttons": [ "6" ],
    }
    ref = null;
    constructor( image )
    {
        ref = image;
        fe.add_transition_callback( this, "transition" );
    }
    
    function transition( ttype, var, ttime )
    {
        if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
        {
            local cat = " " + fe.game_info(Info.Buttons, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
	}
ButtonsImage(buttons_image);



// Progress bar original code by MarkC74

if (my_config["progress"] == "vertical" )
{
	fe.add_image( "images/bar.png", -flx*0.012, fly*0.05, flw*0.083, flh*0.70 );
		local 	list_inc = fly*0.500 / (fe.list.size-1);	
		local 	current_pos = flx*0.108 + (fe.list.index * list_inc);
		local 	list_pos_image = fe.add_image( "images/circle.png", flx*0.004 , current_pos, flw*0.055, flh*0.078 );
		local 	list_label = fe.add_text( "[Title]",flx*0.014, current_pos, flw*0.038, flh*0.073);
			list_label.font="captain"
			colors( list_label, my_config["slider_color"], 0 );
			
	function progress_bar( ttype, var, ttime )
		{
			current_pos = fly*0.105 + (fe.list.index*list_inc);
			list_pos_image.y = current_pos+3;
			list_label.y = current_pos;	
			return false;
		}
	fe.add_transition_callback( "progress_bar" );
}

if (my_config["progress"] == "horizontal" )
{
	fe.add_image( "images/bar_h.png", flx*0.00, fly*0.93, flw*1.00, flh*0.083 );
		local 	list_inc = fly*0.805 / (fe.list.size-1);
		local 	current_pos = flx*0.100 + (fe.list.index * list_inc);
		local 	list_pos_image = fe.add_image( "images/circle.png", current_pos, fly*0.940, flw*0.032, flh*0.055 );
		local 	list_label = fe.add_text( "[Title]",current_pos, fly*0.939, flw*0.0375, flh*0.050);
			list_label.font="captain"
			colors( list_label, my_config["slider_color"], 0 );
			
	function progress_bar( ttype, var, ttime )	
		{
			current_pos = flx*0.179 + (fe.list.index*list_inc);
			list_pos_image.x = current_pos+2;
			list_label.x = current_pos;	
			return false;
		}
	fe.add_transition_callback( "progress_bar" );
}


// game select sound

function select_sound( ttype, var, ttime ) {
 switch ( ttype ) {

  case Transition.ToNewSelection:
	      local sound = fe.add_sound("sounds/game.mp3");
	      sound.playing=true;
  break;
  }
 return false;
}
fe.add_transition_callback( "select_sound" );